if defined?(ChefSpec)
  ################
  # docker_service
  ################
  def create_docker_service(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_service, :create, resource_name)
  end

  def delete_docker_service(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_service, :delete, resource_name)
  end

  def start_docker_service(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_service, :start, resource_name)
  end

  def stop_docker_service(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_service, :stop, resource_name)
  end

  def restart_docker_service(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_service, :restart, resource_name)
  end

  ##############
  # docker_image
  ##############
  def build_docker_image(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_image, :build, resource_name)
  end

  def build_if_missing_docker_image(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_image, :build_if_missing, resource_name)
  end

  def pull_docker_image(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_image, :pull, resource_name)
  end

  def pull_if_missing_docker_image(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_image, :pull_if_missing, resource_name)
  end

  def import_docker_image(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_image, :import, resource_name)
  end

  def push_docker_image(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_image, :push, resource_name)
  end

  def remove_docker_image(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_image, :remove, resource_name)
  end

  def save_docker_image(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_image, :save, resource_name)
  end

  ##################
  # docker_container
  ##################

  def create_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :create, resource_name)
  end

  def start_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :start, resource_name)
  end

  def stop_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :stop, resource_name)
  end

  def kill_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :kill, resource_name)
  end

  def run_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :run, resource_name)
  end

  def run_if_missing_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :run_if_missing, resource_name)
  end

  def pause_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :pause, resource_name)
  end

  def unpause_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :unpause, resource_name)
  end

  def restart_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :restart, resource_name)
  end

  def redeploy_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :redeploy, resource_name)
  end

  def delete_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :delete, resource_name)
  end

  def remove_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :remove, resource_name)
  end

  def remove_link_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :remove_link, resource_name)
  end

  def commit_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :commit, resource_name)
  end

  def export_docker_container(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_container, :export, resource_name)
  end

  ##############
  # docker_tag
  ##############

  def tag_docker_tag(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_tag, :tag, resource_name)
  end

  #################
  # docker_registry
  #################

  def login_docker_registry(resource_name)
    ChefSpec::Matchers::ResourceMatcher.new(:docker_registry, :login, resource_name)
  end

end
